
% Load data
load linearRegressionData.mat

% Plot data
figure(1);
plot(X,y,'b.')
title('Training Data');
hold on
yl = ylim;
xl = xlim;

% Add a bias variable
n = size(X,1);
X = [ones(n,1) X];

% Fit least-squares estimator
w = fitL2(X,y);

% Draw model prediction
plot([0 1],[[1 0]*w [1 1]*w],'g-');

% Draw test data
figure(2);
plot(Xtest,ytest,'b.');
title('Testing Data');
hold on
plot([0 1],[[1 0]*w [1 1]*w],'g-');
ylim(yl);
xlim(xl);

% Compute test error
T = length(ytest);
Xtest = [ones(T,1) Xtest];
yHat = Xtest*w;
avgTestError = sum((yHat - ytest).^2)/T